<?php

////////////////////
 // 由CodeGenerator创建。
 // Copyright (C) gwang (wanggangzero@qq.com), Loyalsoft@sjz Inc
 // author： gwang 
 // 日期: 2020-09-25 16:15:31
////////////////////

/**
 * 常量配置数据 
 */
class GameConfig {
// <editor-fold defaultstate="collapsed" desc="  基础代码 ">    
    /**
     * 是否启用codegen 
     */
    private static function isCG()  {
        return defined('CodeGen_Enabled') && CodeGen_Enabled; 
    }
    /**
     * @var bool 分区是否使用独立的常量配置数据
     */
    private static $useZoneId = false;
    /**
     * 追加分区列表字符串
     * @return string
     */
    private static function zoneid()
    {
        global $zoneid;
        return self::$useZoneId ? "-zone$zoneid" : "";
    }
    /**
     * 初始化指定变量, 非null的情况下直接跳出
     * 可能从文件中或者redis中获取原始数据对变量进行初始化
     * @param mixed $a 变量
     * @param string $modelName 用来初始化变量的资源名称
     * @param bool $isHash 数据是否采用hash结构(否:普通字符串)
     */
    static private function initValue(&$a, $modelName, $isHash = true)
    {
        $key = 'gamecfg-' . $modelName . self::zoneid();
        if (is_null($a)) {
            if (self::isCG()) {
                $a = include $key . '.php';
            } else {
                $a = $isHash ? gMem()->hgetall($key) : gMem()->get($key);
            }
        }
        return $a;
    }
    /** 
     * 获取hash结构的一个item
     * @param string $modelName 模块名称
     * @param mixed/string/int $itemId 索引
     * @return mixed
     */
    private static function get_hash_item($modelName, $itemId)
    {
        if (self::isCG()) {
            $data = self::$modelName();
            if (property_exists($data, $itemId)) {
                return $data->$itemId;
            }
        } else {
            $key = 'gamecfg-' . $modelName . self::zoneid();
            return gMem()->hget($key, $itemId);
        }
        return null;
    }
// </editor-fold>
    /**
    * 全局参数
    * @return \globalsettings
    */
    public static function globalsettings()
    { 
        static $a = null; 
        return self::initValue($a, 'globalsettings');
    }
    /**
    * 英雄模块
    * @return \hero
    */
    public static function hero()
    { 
        static $a = null; 
        return self::initValue($a, 'hero');
    }
    /**
    * @return \sm_hero hero item数据 
    */
    public static function hero_getItem($itemid)
    { 
        return self::get_hash_item('hero', $itemid);
    }
    /**
    * 英雄的升级（属性加成）
    * @return \heroextra_level
    */
    public static function heroextra_level()
    { 
        static $a = null; 
        return self::initValue($a, 'heroextra_level');
    }
    /**
    * @return \sm_heroextra_level heroextra_level item数据 
    */
    public static function heroextra_level_getItem($heroId, $quality)
    { 
        return self::get_hash_item('heroextra_level', $heroId)->$quality;
    }
    /**
    * 开服七天活动
    * @return \day7
    */
    public static function day7()
    { 
        static $a = null; 
        return self::initValue($a, 'day7');
    }
    /**
    * @return \sm_day7 day7 item数据 
    */
    public static function day7_getItem($itemid)
    { 
        return self::get_hash_item('day7', $itemid);
    }
    /**
    * [废弃]
    * @return \item
    */
    public static function item()
    { 
        static $a = null; 
        return self::initValue($a, 'item');
    }
    /**
    * @return \sm_item item item数据 
    */
    public static function item_getItem($itemid)
    { 
        return self::get_hash_item('item', $itemid);
    }
    /**
    * [废弃]
    * @return \itemlevel
    */
    public static function itemlevel()
    { 
        static $a = null; 
        return self::initValue($a, 'itemlevel');
    }
    /**
    * @return \sm_itemlevel itemlevel item数据 
    */
    public static function itemlevel_getItem($itemid)
    { 
        return self::get_hash_item('itemlevel', $itemid);
    }
    /**
    * 英雄的好感度提升（消耗金币）
    * @return \heroextra_favor
    */
    public static function heroextra_favor()
    { 
        static $a = null; 
        return self::initValue($a, 'heroextra_favor');
    }
    /**
    * @return \sm_heroextra_favor heroextra_favor item数据 
    */
    public static function heroextra_favor_getItem($itemid)
    { 
        return self::get_hash_item('heroextra_favor', $itemid);
    }
    /**
    * 英雄的升级——每级成长消耗经验需求表
    * @return \hero_levelexp
    */
    public static function hero_levelexp()
    { 
        static $a = null; 
        return self::initValue($a, 'hero_levelexp');
    }
    /**
    * @return \sm_hero_levelexp hero_levelexp item数据 
    */
    public static function hero_levelexp_getItem($itemid)
    { 
        return self::get_hash_item('hero_levelexp', $itemid);
    }
    /**
    * 英雄的升星（消耗金币+ 属性加成）
    * @return \heroextra_star
    */
    public static function heroextra_star()
    { 
        static $a = null; 
        return self::initValue($a, 'heroextra_star');
    }
    /**
    * @return \sm_heroextra_star heroextra_star item数据 
    */
    public static function heroextra_star_getItem($itemid)
    { 
        return self::get_hash_item('heroextra_star', $itemid);
    }
    /**
    * 英雄的升阶（消耗金币+ 属性加成）
    * @return \heroextra_dengjie
    */
    public static function heroextra_dengjie()
    { 
        static $a = null; 
        return self::initValue($a, 'heroextra_dengjie');
    }
    /**
    * @return \sm_heroextra_dengjie heroextra_dengjie item数据 
    */
    public static function heroextra_dengjie_getItem($itemid)
    { 
        return self::get_hash_item('heroextra_dengjie', $itemid);
    }
    /**
    * 关卡
    * @return \gate
    */
    public static function gate()
    { 
        static $a = null; 
        return self::initValue($a, 'gate');
    }
    /**
    * @return \sm_gate gate item数据 
    */
    public static function gate_getItem($itemid)
    { 
        return self::get_hash_item('gate', $itemid);
    }
    /**
    * 关卡波茨数据
    * @return \gatelevel
    */
    public static function gatelevel()
    { 
        static $a = null; 
        return self::initValue($a, 'gatelevel');
    }
    /**
    * @return \sm_gatelevel gatelevel item数据 
    */
    public static function gatelevel_getItem($itemid)
    { 
        return self::get_hash_item('gatelevel', $itemid);
    }
    /**
    * 关卡—— 星级奖励
    * @return \gate_starreward
    */
    public static function gate_starreward()
    { 
        static $a = null; 
        return self::initValue($a, 'gate_starreward');
    }
    /**
    * @return \sm_gate_starreward gate_starreward item数据 
    */
    public static function gate_starreward_getItem($chapterId, $hardLevel)
    { 
        return self::get_hash_item('gate_starreward', "$chapterId-$hardLevel");
    }
    /**
    * 任务
    * @return \task
    */
    public static function task()
    { 
        static $a = null; 
        return self::initValue($a, 'task');
    }
    /**
    * @return \sm_task task item数据 
    */
    public static function task_getItem($itemid)
    { 
        return self::get_hash_item('task', $itemid);
    }
    /**
    * 
    * @return \playerlevel
    */
    public static function playerlevel()
    { 
        static $a = null; 
        return self::initValue($a, 'playerlevel');
    }
    /**
    * @return \sm_playerlevel playerlevel item数据 
    */
    public static function playerlevel_getItem($itemid)
    { 
        return self::get_hash_item('playerlevel', $itemid);
    }
    /**
    * 言灵类道具
    * @return \item_yanling
    */
    public static function item_yanling()
    { 
        static $a = null; 
        return self::initValue($a, 'item_yanling');
    }
    /**
    * @return \sm_item_yanling item_yanling item数据 
    */
    public static function item_yanling_getItem($itemid)
    { 
        return self::get_hash_item('item_yanling', $itemid);
    }
    /**
    * 技能升级消耗金币
    * @return \skill_upgrade_cost
    */
    public static function skill_upgrade_cost()
    { 
        static $a = null; 
        return self::initValue($a, 'skill_upgrade_cost');
    }
    /**
    * @return \sm_skill_upgrade_cost skill_upgrade_cost item数据 
    */
    public static function skill_upgrade_cost_getItem($itemid)
    { 
        return self::get_hash_item('skill_upgrade_cost', $itemid);
    }
    /**
    * 商城
    * @return \shop
    */
    public static function shop()
    { 
        static $a = null; 
        return self::initValue($a, 'shop');
    }
    /**
    * @return \sm_shop shop item数据 
    */
    public static function shop_getItem($itemid)
    { 
        return self::get_hash_item('shop', $itemid);
    }
    /**
    * 停服计划
    * @return \service_schedule
    */
    public static function service_schedule()
    { 
        static $a = null; 
        return self::initValue($a, 'service_schedule');
    }
    /**
    * @return \sm_service_schedule service_schedule item数据 
    */
    public static function service_schedule_getItem($itemid)
    { 
        return self::get_hash_item('service_schedule', $itemid);
    }
    /**
    * 无穷无尽关卡模式
    * @return \gate_forever
    */
    public static function gate_forever()
    { 
        static $a = null; 
        return self::initValue($a, 'gate_forever');
    }
    /**
    * @return \sm_gate_forever gate_forever item数据 
    */
    public static function gate_forever_getItem($itemid)
    { 
        return self::get_hash_item('gate_forever', $itemid);
    }
    /**
    * 系统邮件
    * @return \sysmail
    */
    public static function sysmail()
    { 
        static $a = null; 
        return self::initValue($a, 'sysmail');
    }
    /**
    * @return \sm_sysmail sysmail item数据 
    */
    public static function sysmail_getItem($itemid)
    { 
        return self::get_hash_item('sysmail', $itemid);
    }
    /**
    * 活跃点奖励表
    * @return \task_active_reward
    */
    public static function task_active_reward()
    { 
        static $a = null; 
        return self::initValue($a, 'task_active_reward');
    }
    /**
    * @return \sm_task_active_reward task_active_reward item数据 
    */
    public static function task_active_reward_getItem($itemid)
    { 
        return self::get_hash_item('task_active_reward', $itemid);
    }
    /**
    * 竞技场 上榜单奖励
    * @return \pvp_rankreward
    */
    public static function pvp_rankreward()
    { 
        static $a = null; 
        return self::initValue($a, 'pvp_rankreward');
    }
    /**
    * @return \sm_pvp_rankreward pvp_rankreward item数据 
    */
    public static function pvp_rankreward_getItem($itemid)
    { 
        return self::get_hash_item('pvp_rankreward', $itemid);
    }
    /**
    * 竞技 商店
    * @return \pvp_shop
    */
    public static function pvp_shop()
    { 
        static $a = null; 
        return self::initValue($a, 'pvp_shop');
    }
    /**
    * @return \sm_pvp_shop pvp_shop item数据 
    */
    public static function pvp_shop_getItem($itemid)
    { 
        return self::get_hash_item('pvp_shop', $itemid);
    }
    /**
    * 熔炼实验室
    * @return \smelting
    */
    public static function smelting()
    { 
        static $a = null; 
        return self::initValue($a, 'smelting');
    }
    /**
    * @return \sm_smelting smelting item数据 
    */
    public static function smelting_getItem($itemid)
    { 
        return self::get_hash_item('smelting', $itemid);
    }
    /**
    * 配置的关卡相关的战斗数据
    * @return \gate_combat
    */
    public static function gate_combat()
    { 
        static $a = null; 
        return self::initValue($a, 'gate_combat');
    }
    /**
    * @return \sm_gate_combat gate_combat item数据 
    */
    public static function gate_combat_getItem($itemid)
    { 
        return self::get_hash_item('gate_combat', $itemid);
    }
    /**
    * [废弃]
    * @return \gate_carbon_content
    */
    public static function gate_carbon_content()
    { 
        static $a = null; 
        return self::initValue($a, 'gate_carbon_content');
    }
    /**
    * @return \sm_gate_carbon_content gate_carbon_content item数据 
    */
    public static function gate_carbon_content_getItem($itemid)
    { 
        return self::get_hash_item('gate_carbon_content', $itemid);
    }
    /**
    * 每日任务
    * @return \task_daily
    */
    public static function task_daily()
    { 
        static $a = null; 
        return self::initValue($a, 'task_daily');
    }
    /**
    * @return \sm_task_daily task_daily item数据 
    */
    public static function task_daily_getItem($itemid)
    { 
        return self::get_hash_item('task_daily', $itemid);
    }
    /**
    * 抽奖保底数据
    * @return \choujiang_baodi
    */
    public static function choujiang_baodi()
    { 
        static $a = null; 
        return self::initValue($a, 'choujiang_baodi');
    }
    /**
    * @return \sm_choujiang_baodi choujiang_baodi item数据 
    */
    public static function choujiang_baodi_getItem($typeId, $cishu)
    { 
        return self::get_hash_item('choujiang_baodi', "$typeId-$cishu");
    }
    /**
    * 英雄的升级——成长可消耗的道具表
    * @return \hero_levelexp_costitem
    */
    public static function hero_levelexp_costitem()
    { 
        static $a = null; 
        return self::initValue($a, 'hero_levelexp_costitem');
    }
    /**
    * @return \sm_hero_levelexp_costitem hero_levelexp_costitem item数据 
    */
    public static function hero_levelexp_costitem_getItem($itemid)
    { 
        return self::get_hash_item('hero_levelexp_costitem', $itemid);
    }
    /**
    * 抽奖设置数据
    * @return \choujiang_settings
    */
    public static function choujiang_settings()
    { 
        static $a = null; 
        return self::initValue($a, 'choujiang_settings');
    }
    /**
    * @return \sm_choujiang_settings choujiang_settings item数据 
    */
    public static function choujiang_settings_getItem($itemid)
    { 
        return self::get_hash_item('choujiang_settings', $itemid);
    }
    /**
    * 引导步骤
    * @return \guide_step
    */
    public static function guide_step()
    { 
        static $a = null; 
        return self::initValue($a, 'guide_step');
    }
    /**
    * @return \sm_guide_step guide_step item数据 
    */
    public static function guide_step_getItem($itemid)
    { 
        return self::get_hash_item('guide_step', $itemid);
    }
    /**
    * 引导触发
    * @return \guide_trigger
    */
    public static function guide_trigger()
    { 
        static $a = null; 
        return self::initValue($a, 'guide_trigger');
    }
    /**
    * @return \sm_guide_trigger guide_trigger item数据 
    */
    public static function guide_trigger_getItem($itemid)
    { 
        return self::get_hash_item('guide_trigger', $itemid);
    }
    /**
    * 任务节点
    * @return \task_node
    */
    public static function task_node()
    { 
        static $a = null; 
        return self::initValue($a, 'task_node');
    }
    /**
    * @return \sm_task_node task_node item数据 
    */
    public static function task_node_getItem($itemid)
    { 
        return self::get_hash_item('task_node', $itemid);
    }
    /**
    * 宝箱
    * @return \box
    */
    public static function box()
    { 
        static $a = null; 
        return self::initValue($a, 'box');
    }
    /**
    * @return \sm_box box item数据 
    */
    public static function box_getItem($itemid)
    { 
        return self::get_hash_item('box', $itemid);
    }
    /**
    * 宝箱的奖池
    * @return \boxpool
    */
    public static function boxpool()
    { 
        static $a = null; 
        return self::initValue($a, 'boxpool');
    }
    /**
    * @return \sm_boxpool boxpool item数据 
    */
    public static function boxpool_getItem($itemid)
    { 
        return self::get_hash_item('boxpool', $itemid);
    }
    /**
    * 英雄————神血系统
    * @return \heroextra_godblood
    */
    public static function heroextra_godblood()
    { 
        static $a = null; 
        return self::initValue($a, 'heroextra_godblood');
    }
    /**
    * @return \sm_heroextra_godblood heroextra_godblood item数据 
    */
    public static function heroextra_godblood_getItem($itemid)
    { 
        return self::get_hash_item('heroextra_godblood', $itemid);
    }
    /**
    * 碎片
    * @return \segment
    */
    public static function segment()
    { 
        static $a = null; 
        return self::initValue($a, 'segment');
    }
    /**
    * @return \sm_segment segment item数据 
    */
    public static function segment_getItem($itemid)
    { 
        return self::get_hash_item('segment', $itemid);
    }
    /**
    * 
    * @return \gate_world
    */
    public static function gate_world()
    { 
        static $a = null; 
        return self::initValue($a, 'gate_world');
    }
    /**
    * @return \sm_gate_world gate_world item数据 
    */
    public static function gate_world_getItem($itemid)
    { 
        return self::get_hash_item('gate_world', $itemid);
    }
    /**
    * [废弃]
    * @return \gate_city
    */
    public static function gate_city()
    { 
        static $a = null; 
        return self::initValue($a, 'gate_city');
    }
    /**
    * @return \sm_gate_city gate_city item数据 
    */
    public static function gate_city_getItem($itemid)
    { 
        return self::get_hash_item('gate_city', $itemid);
    }
    /**
    * 神秘商城道具表-by goodstype
    * @return \secretshop_goodsType
    */
    public static function secretshop_goodsType()
    { 
        static $a = null; 
        return self::initValue($a, 'secretshop_goodsType');
    }
    /**
    * @return \sm_secretshop_goodsType secretshop_goodsType item数据 
    */
    public static function secretshop_goodsType_getItem($itemid)
    { 
        return self::get_hash_item('secretshop_goodsType', $itemid);
    }
    /**
    * 神秘商城刷新价格表
    * @return \secretshop_refresh
    */
    public static function secretshop_refresh()
    { 
        static $a = null; 
        return self::initValue($a, 'secretshop_refresh');
    }
    /**
    * @return \sm_secretshop_refresh secretshop_refresh item数据 
    */
    public static function secretshop_refresh_getItem($itemid)
    { 
        return self::get_hash_item('secretshop_refresh', $itemid);
    }
    /**
    * 神秘商城道具表-by typeId
    * @return \secretshop_typeId
    */
    public static function secretshop_typeId()
    { 
        static $a = null; 
        return self::initValue($a, 'secretshop_typeId');
    }
    /**
    * @return \sm_secretshop_typeId secretshop_typeId item数据 
    */
    public static function secretshop_typeId_getItem($itemid)
    { 
        return self::get_hash_item('secretshop_typeId', $itemid);
    }
    /**
    * 客户端版本信息
    * @return \clientVersionHistory
    */
    public static function clientVersionHistory()
    { 
        static $a = null; 
        return self::initValue($a, 'clientVersionHistory');
    }
    /**
    * @return \sm_clientVersionHistory clientVersionHistory item数据 
    */
    public static function clientVersionHistory_getItem($itemid)
    { 
        return self::get_hash_item('clientVersionHistory', $itemid);
    }
    /**
    * 分区列表
    * @return \zonelist
    */
    public static function zonelist()
    { 
        static $a = null; 
        return self::initValue($a, 'zonelist');
    }
    /**
    * @return \sm_zonelist zonelist item数据 
    */
    public static function zonelist_getItem($itemid)
    { 
        return self::get_hash_item('zonelist', $itemid);
    }
    /**
    * 兑换码礼包
    * @return \tokenGift
    */
    public static function tokenGift()
    { 
        static $a = null; 
        return self::initValue($a, 'tokenGift');
    }
    /**
    * @return \sm_tokenGift tokenGift item数据 
    */
    public static function tokenGift_getItem($itemid)
    { 
        return self::get_hash_item('tokenGift', $itemid);
    }
    /**
    * 活动配置
    * @return \activity
    */
    public static function activity()
    { 
        static $a = null; 
        return self::initValue($a, 'activity');
    }
    /**
    * @return \sm_activity activity item数据 
    */
    public static function activity_getItem($itemid)
    { 
        return self::get_hash_item('activity', $itemid);
    }
    /**
    * 碎片融合的概率表
    * @return \segment_ronghe
    */
    public static function segment_ronghe()
    { 
        static $a = null; 
        return self::initValue($a, 'segment_ronghe');
    }
    /**
    * @return \sm_segment_ronghe segment_ronghe item数据 
    */
    public static function segment_ronghe_getItem($itemid)
    { 
        return self::get_hash_item('segment_ronghe', $itemid);
    }
    /**
    * 碎片_按品质索引
    * @return \segment_byPinzhi
    */
    public static function segment_byPinzhi()
    { 
        static $a = null; 
        return self::initValue($a, 'segment_byPinzhi');
    }
    /**
    * @return \sm_segment_byPinzhi segment_byPinzhi item数据 
    */
    public static function segment_byPinzhi_getItem($quailty, $itemType)
    { 
        return self::get_hash_item('segment_byPinzhi', $quailty)->$itemType;
    }
    /**
    * 宝箱经验卡掉落数据
    * @return \boxJingYanCards
    */
    public static function boxJingYanCards()
    { 
        static $a = null; 
        return self::initValue($a, 'boxJingYanCards');
    }
    /**
    * @return \sm_boxJingYanCards boxJingYanCards item数据 
    */
    public static function boxJingYanCards_getItem($itemid)
    { 
        return self::get_hash_item('boxJingYanCards', $itemid);
    }
    /**
    * 活动: 在线礼包
    * @return \activity_onlinegift
    */
    public static function activity_onlinegift()
    { 
        static $a = null; 
        return self::initValue($a, 'activity_onlinegift');
    }
    /**
    * @return \sm_activity_onlinegift activity_onlinegift item数据 
    */
    public static function activity_onlinegift_getItem($itemid)
    { 
        return self::get_hash_item('activity_onlinegift', $itemid);
    }
    /**
    * GM号的UID
    * @return \GM_uids
    */
    public static function GM_uids()
    { 
        static $a = null; 
        return self::initValue($a, 'GM_uids');
    }
    /**
    * 活动, 全服注册礼包
    * @return \activity_reggift
    */
    public static function activity_reggift()
    { 
        static $a = null; 
        return self::initValue($a, 'activity_reggift');
    }
    /**
    * @return \sm_activity_reggift activity_reggift item数据 
    */
    public static function activity_reggift_getItem($itemid)
    { 
        return self::get_hash_item('activity_reggift', $itemid);
    }
    /**
    * 公会捐献卡牌奖励
    * @return \guilddonatereward
    */
    public static function guilddonatereward()
    { 
        static $a = null; 
        return self::initValue($a, 'guilddonatereward');
    }
    /**
    * @return \sm_guilddonatereward guilddonatereward item数据 
    */
    public static function guilddonatereward_getItem($itemid)
    { 
        return self::get_hash_item('guilddonatereward', $itemid);
    }
    /**
    * 公会等级相关数据
    * @return \guildlevel
    */
    public static function guildlevel()
    { 
        static $a = null; 
        return self::initValue($a, 'guildlevel');
    }
    /**
    * @return \sm_guildlevel guildlevel item数据 
    */
    public static function guildlevel_getItem($itemid)
    { 
        return self::get_hash_item('guildlevel', $itemid);
    }
    /**
    * 公会礼包
    * @return \guildlibao
    */
    public static function guildlibao()
    { 
        static $a = null; 
        return self::initValue($a, 'guildlibao');
    }
    /**
    * @return \sm_guildlibao guildlibao item数据 
    */
    public static function guildlibao_getItem($itemid)
    { 
        return self::get_hash_item('guildlibao', $itemid);
    }
    /**
    * 玩家初始化数据
    * @return \primordial_data
    */
    public static function primordial_data()
    { 
        static $a = null; 
        return self::initValue($a, 'primordial_data');
    }
    /**
    * 英雄技能升级的限定
    * @return \heroextra_skill_lv_limit
    */
    public static function heroextra_skill_lv_limit()
    { 
        static $a = null; 
        return self::initValue($a, 'heroextra_skill_lv_limit');
    }
    /**
    * @return \sm_heroextra_skill_lv_limit heroextra_skill_lv_limit item数据 
    */
    public static function heroextra_skill_lv_limit_getItem($itemid)
    { 
        return self::get_hash_item('heroextra_skill_lv_limit', $itemid);
    }
    /**
    * 武器类道具
    * @return \item_weapon
    */
    public static function item_weapon()
    { 
        static $a = null; 
        return self::initValue($a, 'item_weapon');
    }
    /**
    * @return \sm_item_weapon item_weapon item数据 
    */
    public static function item_weapon_getItem($itemid)
    { 
        return self::get_hash_item('item_weapon', $itemid);
    }
    /**
    * 礼包类道具
    * @return \item_package
    */
    public static function item_package()
    { 
        static $a = null; 
        return self::initValue($a, 'item_package');
    }
    /**
    * @return \sm_item_package item_package item数据 
    */
    public static function item_package_getItem($itemid)
    { 
        return self::get_hash_item('item_package', $itemid);
    }
    /**
    * 强化类道具
    * @return \item_stones
    */
    public static function item_stones()
    { 
        static $a = null; 
        return self::initValue($a, 'item_stones');
    }
    /**
    * @return \sm_item_stones item_stones item数据 
    */
    public static function item_stones_getItem($itemid)
    { 
        return self::get_hash_item('item_stones', $itemid);
    }
    /**
    * 药水类道具
    * @return \item_pills
    */
    public static function item_pills()
    { 
        static $a = null; 
        return self::initValue($a, 'item_pills');
    }
    /**
    * @return \sm_item_pills item_pills item数据 
    */
    public static function item_pills_getItem($itemid)
    { 
        return self::get_hash_item('item_pills', $itemid);
    }
    /**
    * buff类道具
    * @return \item_buffcard
    */
    public static function item_buffcard()
    { 
        static $a = null; 
        return self::initValue($a, 'item_buffcard');
    }
    /**
    * @return \sm_item_buffcard item_buffcard item数据 
    */
    public static function item_buffcard_getItem($itemid)
    { 
        return self::get_hash_item('item_buffcard', $itemid);
    }
    /**
    * 碎片类道具
    * @return \item_segment
    */
    public static function item_segment()
    { 
        static $a = null; 
        return self::initValue($a, 'item_segment');
    }
    /**
    * @return \sm_item_segment item_segment item数据 
    */
    public static function item_segment_getItem($itemid)
    { 
        return self::get_hash_item('item_segment', $itemid);
    }
    /**
    * 道具通用字段表
    * @return \item_base
    */
    public static function item_base()
    { 
        static $a = null; 
        return self::initValue($a, 'item_base');
    }
    /**
    * @return \sm_item_base item_base item数据 
    */
    public static function item_base_getItem($itemid)
    { 
        return self::get_hash_item('item_base', $itemid);
    }
    /**
    * 子技能表
    * @return \subSkill
    */
    public static function subSkill()
    { 
        static $a = null; 
        return self::initValue($a, 'subSkill');
    }
    /**
    * @return \sm_subSkill subSkill item数据 
    */
    public static function subSkill_getItem($itemid)
    { 
        return self::get_hash_item('subSkill', $itemid);
    }
    /**
    * 宝箱类道具
    * @return \item_box
    */
    public static function item_box()
    { 
        static $a = null; 
        return self::initValue($a, 'item_box');
    }
    /**
    * @return \sm_item_box item_box item数据 
    */
    public static function item_box_getItem($itemid)
    { 
        return self::get_hash_item('item_box', $itemid);
    }
    /**
    * 关卡-通关条件
    * @return \gate_passCondition
    */
    public static function gate_passCondition()
    { 
        static $a = null; 
        return self::initValue($a, 'gate_passCondition');
    }
    /**
    * @return \sm_gate_passCondition gate_passCondition item数据 
    */
    public static function gate_passCondition_getItem($itemid)
    { 
        return self::get_hash_item('gate_passCondition', $itemid);
    }
    /**
    * 元素相克关系表
    * @return \attack_relation
    */
    public static function attack_relation()
    { 
        static $a = null; 
        return self::initValue($a, 'attack_relation');
    }
    /**
    * @return \sm_attack_relation attack_relation item数据 
    */
    public static function attack_relation_getItem($attack1, $attack2)
    { 
        return self::get_hash_item('attack_relation', "$attack1-$attack2");
    }
    /**
    * 战斗力榜全服突破奖励
    * @return \rankreward_fpower
    */
    public static function rankreward_fpower()
    { 
        static $a = null; 
        return self::initValue($a, 'rankreward_fpower');
    }
    /**
    * @return \sm_rankreward_fpower rankreward_fpower item数据 
    */
    public static function rankreward_fpower_getItem($itemid)
    { 
        return self::get_hash_item('rankreward_fpower', $itemid);
    }
    /**
    * 合体技能
    * @return \skill_cross
    */
    public static function skill_cross()
    { 
        static $a = null; 
        return self::initValue($a, 'skill_cross');
    }
    /**
    * @return \sm_skill_cross skill_cross item数据 
    */
    public static function skill_cross_getItem($itemid)
    { 
        return self::get_hash_item('skill_cross', $itemid);
    }
    /**
    * 通关榜突破奖励
    * @return \rankreward_passgate
    */
    public static function rankreward_passgate()
    { 
        static $a = null; 
        return self::initValue($a, 'rankreward_passgate');
    }
    /**
    * @return \sm_rankreward_passgate rankreward_passgate item数据 
    */
    public static function rankreward_passgate_getItem($itemid)
    { 
        return self::get_hash_item('rankreward_passgate', $itemid);
    }
    /**
    * 言灵召唤书
    * @return \item_yanlingbook
    */
    public static function item_yanlingbook()
    { 
        static $a = null; 
        return self::initValue($a, 'item_yanlingbook');
    }
    /**
    * @return \sm_item_yanlingbook item_yanlingbook item数据 
    */
    public static function item_yanlingbook_getItem($itemid)
    { 
        return self::get_hash_item('item_yanlingbook', $itemid);
    }
    /**
    * 言灵进阶表
    * @return \yanling_upgrade
    */
    public static function yanling_upgrade()
    { 
        static $a = null; 
        return self::initValue($a, 'yanling_upgrade');
    }
    /**
    * @return \sm_yanling_upgrade yanling_upgrade item数据 
    */
    public static function yanling_upgrade_getItem($typeId, $grade)
    { 
        return self::get_hash_item('yanling_upgrade', $typeId)->$grade;
    }
    /**
    * 功能引导模块
    * @return \guide_module
    */
    public static function guide_module()
    { 
        static $a = null; 
        return self::initValue($a, 'guide_module');
    }
    /**
    * @return \sm_guide_module guide_module item数据 
    */
    public static function guide_module_getItem($itemid)
    { 
        return self::get_hash_item('guide_module', $itemid);
    }
    /**
    * 活动: 七日签到
    * @return \activity_day7
    */
    public static function activity_day7()
    { 
        static $a = null; 
        return self::initValue($a, 'activity_day7');
    }
    /**
    * @return \sm_activity_day7 activity_day7 item数据 
    */
    public static function activity_day7_getItem($itemid)
    { 
        return self::get_hash_item('activity_day7', $itemid);
    }
    /**
    * 限购商城
    * @return \shop_limit
    */
    public static function shop_limit()
    { 
        static $a = null; 
        return self::initValue($a, 'shop_limit');
    }
    /**
    * @return \sm_shop_limit shop_limit item数据 
    */
    public static function shop_limit_getItem($itemid)
    { 
        return self::get_hash_item('shop_limit', $itemid);
    }
    /**
    * 月卡商城
    * @return \shop_monthVIP
    */
    public static function shop_monthVIP()
    { 
        static $a = null; 
        return self::initValue($a, 'shop_monthVIP');
    }
    /**
    * @return \sm_shop_monthVIP shop_monthVIP item数据 
    */
    public static function shop_monthVIP_getItem($itemid)
    { 
        return self::get_hash_item('shop_monthVIP', $itemid);
    }
    /**
    * 掉落数据表
    * @return \drop
    */
    public static function drop()
    { 
        static $a = null; 
        return self::initValue($a, 'drop');
    }
    /**
    * @return \sm_drop drop item数据 
    */
    public static function drop_getItem($itemid)
    { 
        return self::get_hash_item('drop', $itemid);
    }
    /**
    * 当前版本(时间戳)
    * @return \ver
    */
    public static function ver()
    { 
        static $a = null; 
        return self::initValue($a, 'ver', false);
    }
    /**
    * 客户端配置数据
    * @return \client
    */
    public static function client()
    { 
        static $a = null; 
        return self::initValue($a, 'client', false);
    }
}

