<?php

namespace loyalsoft;

/**
 * 框架封装的一部分通用/常见Event.
 * @version
 *          1.0.0 Created at 2017-8-28.   by --gwang
 * @author gwang (mail@wanggangzero.cn)
 * @copyright ? 2017-8-28, SJZ LoyalSoft Corporation & gwang. All rights reserved.
 */
class EventProc {

    public static function procMain($req) {
        switch ($req->cmd) {
            case CmdCode::cmd_event_GetNotifications:                           # 7201 拉取角标通知列表
                return self::GetCornerSignNotifications($req);
            default:
                return Resp::err(ErrCode::cmd_err);
        }
    }

//put your code here

    /**
     * [7201] 拉取角标通知
     * @param req $req
     */
    static function GetCornerSignNotifications($req) {
        // 这里直接返回, 将来开发对应的触发逻辑, 给数组中添加相应的值
        $arr = array_values(array_unique($req->userInfo->game->privateState->cornerSignNotifications)); # 返回值去重
        $req->userInfo->game->privateState->cornerSignNotifications = [];       # 清理记录
        UserProc::updateUserInfo();
        return Resp::ok(array("notifications" => $arr));                        # 返回
    }

    static function Init() {
        Event::register('onpay', array(new UserProfile(req()->userInfo->game->profile), "OnPay"));
    }

    /**
     * 收到请求
     */
    static function OnRequest() {
        
    }

    /**
     * 处理完毕准备返回
     */
    static function AfterResponse() {
        
    }

    /**
     * 当天第一次登录
     */
    static function OnNewDay() {
        
    }

    /**
     * 当周第一次登录(周一)
     */
    static function OnNewWeek() {
        
    }

}
